/****************************
*   gpsWeatherStation_iPad  *
*   Version 2.0 27.07.2012  *
*     created by oldser     *
*    http://itheming.de/    *
*  It doesn't work in the   *
* SummerBoard Mode, please  *
*     turn it out.          *
****************************/
/* use your own theme functions in this file */

function updateDisplay() {
	mon = obj.Today.split(' ');
	document.getElementById("day0").innerHTML = ForecastDayNames(obj.Today);
	document.getElementById("day0lohi").innerHTML = obj.TodayLo + "°" + obj.TodayHi + "°";
	document.getElementById("day0icon").src="small_icons/"+obj.TodayCode+"_small.png";
	mon = obj.Day1Date.split(' ');
	document.getElementById("day1").innerHTML = ForecastDayNames(obj.Day1);
	document.getElementById("day1lohi").innerHTML = obj.Day1Lo + "°" + obj.Day1Hi + "°";
	document.getElementById("day1icon").src="small_icons/"+obj.Day1Code+"_small.png";
	mon = obj.Day2Date.split(' ');
	document.getElementById("day2").innerHTML = ForecastDayNames(obj.Day2);
	document.getElementById("day2lohi").innerHTML = obj.Day2Lo + "°" + obj.Day2Hi + "°";
	document.getElementById("day2icon").src="small_icons/"+obj.Day2Code+"_small.png";
	mon = obj.Day3Date.split(' ');
	document.getElementById("day3").innerHTML = ForecastDayNames(obj.Day3);
	document.getElementById("day3lohi").innerHTML = obj.Day3Lo + "°" + obj.Day3Hi + "°";
	document.getElementById("day3icon").src="small_icons/"+obj.Day3Code+"_small.png";
	mon = obj.Day4Date.split(' ');
	document.getElementById("day4").innerHTML = ForecastDayNames(obj.Day4);
	document.getElementById("day4lohi").innerHTML = obj.Day4Lo + "°" + obj.Day4Hi + "°";
	document.getElementById("day4icon").src="small_icons/"+obj.Day4Code+"_small.png";
	
	document.getElementById("last_date").innerHTML = lastDate(obj.date);
	document.getElementById("last_time").innerHTML = lastTime(obj.date);
	
	document.getElementById('mondphase').src= mond;
	document.getElementById("sunup").innerHTML = timeKorr(sonnenaufgangzeit.replace('.',':'));
	document.getElementById("sundown").innerHTML = timeKorr(sonnenuntergangzeit.replace('.',':'));
	document.getElementById("moonup").innerHTML = timeKorr(mondaufgangzeit.replace('.',':'));
	document.getElementById("moondown").innerHTML = timeKorr(monduntergangzeit.replace('.',':'));
	
	document.getElementById("city").innerHTML = obj.city;
	document.getElementById("temp").innerHTML = obj.temp + "°";
	document.getElementById("chill").innerHTML = obj.chill + "°";
	windr = Math.round(obj.winddir / 22.5);
	
	if(weather_unit == 'c') {
		document.getElementById("desc").innerHTML = weatherNow[obj.icon];
		document.getElementById("winddir").innerHTML = windDirection[windr];
		document.getElementById("humidity").innerHTML = "Luftfeuchte<br>" + obj.humidity + "%";
		document.getElementById("visibility").innerHTML = "Sicht<br>" + obj.visibility + " " + obj.visibilityunit;
		document.getElementById("pressure").innerHTML = "Luftdruck<br>" + obj.pressure + " " + obj.pressureunit;
		
	}
	else {
		document.getElementById("desc").innerHTML = obj.description;
		document.getElementById("winddir").innerHTML = windDirection[windr+17];
		document.getElementById("humidity").innerHTML = "Humidity<br>" + obj.humidity + "%";
		document.getElementById("visibility").innerHTML = "Visibility<br>" + obj.visibility + " " + obj.visibilityunit;
		document.getElementById("pressure").innerHTML = "Pressure<br>" + obj.pressure + " " + obj.pressureunit;
	}
	document.getElementById("winddeg").innerHTML = obj.winddir + "°";
	document.getElementById("needle").style.webkitTransform = "rotate(" + obj.winddir + "deg)";
	document.getElementById("wind_speed").innerHTML = obj.windspeed + obj.windunit;
	
	
	
}

var obj = {error:false, errorString:null};
var lastWeather = 0;
var nextWeather = 15*60*1000;

setInterval( function time() {
	if(gps_weather) UpdateLocation();
	
	
		
	
	var currentTime = new Date ();
	if (locale != woeid && woeid != "") {
	  locale = woeid;
	  readWeather();    
	  AufUnterAusgabe();
	  phasenberechnung();
	}
	if (lastWeather == 0){
	  readWeather();
	  lastWeather = currentTime.getTime();
	  AufUnterAusgabe();
	  phasenberechnung();
	}
	else{
	  if (currentTime.getTime() - lastWeather >= nextWeather){
	    lastWeather = currentTime.getTime();
	   	readWeather();
		AufUnterAusgabe();
		phasenberechnung();
	  }
	}	

	
	}, 1000 );
	
var weatherNow =
[
	"Tornado","Tropischer Sturm","Orkan","Heftiges Gewitter","Gewitter","Regen und Schnee",
	"Regen und Eisregen","Schnee und Eisregen","Gefrierender Nieselregen","Nieselregen",
	"Gefrierender Regen","Schauer","Schauer","Schneeschauer","Leichte Schneeschauer","Stürmiger Schneefall",
	"Schnee","Hagel","Eisregen","Staub","Neblig","Dunst","Staubig","Stürmisch","Windig","Kalt",
	"Bewölkt","Größtenteils bewölkt","Größtenteils bewölkt","Teilweise bewölkt",
	"Teilweise bewölkt","Klar","Sonnig","Schön","Schön",
	"Regen und Hagel","Heiß","Einzelne Gewitter","Vereinzelte Gewitter","Vereinzelte Gewitter",
	"Vereinzelte Schauer","Starker Schneefall","Vereinzelte Schneeschauer","Starker Schneefall","Teilweise bewölkt",
	"Später Schauer","Schneeschauer","Einzelne Gewitterschauer","N/A"
];

var windDirection =
[
	'N', 'NNO', 'NO', 'ONO', 'O', 'OSO', 'SO', 'SSO', 'S', 'SSW', 'SW', 'WSW', 'W', 'WNW', 'NW', 'NNW', 'N',
	'N', 'NNE', 'NE', 'ENE', 'E', 'ESE', 'SE', 'SSE', 'S', 'SSW', 'SW', 'WSW', 'W', 'WNW', 'NW', 'NNW', 'N'
];

function readWeather() {
	document.getElementById("status").innerHTML = "readWeather";
	
	url="http://weather.yahooapis.com/forecastrss?w="+locale+"&u="+weather_unit;
	// source http://www.w3schools.com/ajax/ajax_xmlhttprequest_create.asp
	var xmlhttp;
 	if (window.XMLHttpRequest) {// code for IE7+, Firefox, Chrome, Opera, Safari
   		xmlhttp=new XMLHttpRequest();
   	}
 	else {// code for IE6, IE5
   		xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
   	}	
	xmlhttp.onreadystatechange=function() {
		if (xmlhttp.readyState==4 && xmlhttp.status == 200) {
     		xmlDoc=xmlhttp.responseXML;
			writeWeather(xmlDoc);
   		}
   	}
	xmlhttp.overrideMimeType("text/xml");
	xmlhttp.open("GET",url,true);
	xmlhttp.send(null);
}

function writeWeather(xmlDoc) {
	var effectiveRoot = findChild(findChild(xmlDoc, "rss"), "channel");
	// make location id for weather forecast
	var yahoo_link    = effectiveRoot.getElementsByTagName("link");
	var dummy         = yahoo_link[0].childNodes[0].nodeValue;
	var dummy1        = dummy.split('forecast/')[1];
	var dummy2        = dummy1.split('_')[0];
	var loc_forecast  = dummy2;
	
	// The location of this forecast
	obj.city = findChild(effectiveRoot, "yweather:location").getAttribute("city");
	// Units for various aspects of the forecast
	obj.tempunit = findChild(effectiveRoot, "yweather:units").getAttribute("temperature");
	obj.visibilityunit = findChild(effectiveRoot, "yweather:units").getAttribute("distance");
	obj.pressureunit = findChild(effectiveRoot, "yweather:units").getAttribute("pressure");
	obj.windunit = findChild(effectiveRoot, "yweather:units").getAttribute("speed");
	// Forecast information about wind
	obj.chill = findChild(effectiveRoot, "yweather:wind").getAttribute("chill");
	obj.winddir = findChild(effectiveRoot, "yweather:wind").getAttribute("direction");
	obj.windspeed = findChild(effectiveRoot, "yweather:wind").getAttribute("speed");
	// Forecast information about current atmospheric pressure, humidity, and visibility
	obj.humidity = findChild(effectiveRoot, "yweather:atmosphere").getAttribute("humidity");	  
	obj.visibility = findChild(effectiveRoot, "yweather:atmosphere").getAttribute("visibility");
	obj.pressure = findChild(effectiveRoot, "yweather:atmosphere").getAttribute("pressure");
	obj.rising = findChild(effectiveRoot, "yweather:atmosphere").getAttribute("rising");
	// Forecast information about current astronomical conditions
	obj.sunrise = findChild(effectiveRoot, "yweather:astronomy").getAttribute("sunrise");
	obj.sunset = findChild(effectiveRoot, "yweather:astronomy").getAttribute("sunset");
	// The current weather conditions
	conditionTag = findChild(findChild(effectiveRoot, "item"), "yweather:condition");
	obj.description = conditionTag.getAttribute("text");
	obj.icon = conditionTag.getAttribute("code");	
	obj.temp = conditionTag.getAttribute("temp");
	obj.date = conditionTag.getAttribute("date");
	
	read4DaysWeather(loc_forecast);	
	
}

function findChild (element, nodeName)
{
	var child;
	for (child = element.firstChild; child != null; child = child.nextSibling)
	{
       if (child.nodeName == nodeName)
		return child;
	}
	return null;
}

function read4DaysWeather(loc_forecast) {
	document.getElementById("status").innerHTML = "read4DaysWeather";
	
	url="http://xml.weather.yahoo.com/forecastrss/"+loc_forecast+"_"+weather_unit+".xml";
	// source http://www.w3schools.com/ajax/ajax_xmlhttprequest_create.asp
	var xml_request;
 	if (window.XMLHttpRequest) {// code for IE7+, Firefox, Chrome, Opera, Safari
   		xml_request=new XMLHttpRequest();
   	}
 	else {// code for IE6, IE5
   		xml_request=new ActiveXObject("Microsoft.XMLHTTP");
   	}	
	xml_request.onreadystatechange=function() {
		if (xml_request.readyState==4 && xml_request.status == 200) {
     		xmlDoc2=xml_request.responseXML;
			write4DaysWeather(xmlDoc2);
			
   		}
   	}
	xml_request.overrideMimeType("text/xml");
	xml_request.open("GET",url,true);
	xml_request.send(null);
}

function write4DaysWeather(xmlDoc2) {
	obj.Today = xmlDoc2.getElementsByTagName("forecast")[0].getAttribute("day");
	obj.TodayHi = xmlDoc2.getElementsByTagName("forecast")[0].getAttribute("high");
	obj.TodayLo = xmlDoc2.getElementsByTagName("forecast")[0].getAttribute("low");
	obj.TodayCode = xmlDoc2.getElementsByTagName("forecast")[0].getAttribute("code");

	obj.Day1 = xmlDoc2.getElementsByTagName("forecast")[1].getAttribute("day");
	obj.Day1Hi = xmlDoc2.getElementsByTagName("forecast")[1].getAttribute("high");
	obj.Day1Lo = xmlDoc2.getElementsByTagName("forecast")[1].getAttribute("low");
	obj.Day1Code = xmlDoc2.getElementsByTagName("forecast")[1].getAttribute("code");
	obj.Day1Date = xmlDoc2.getElementsByTagName("forecast")[1].getAttribute("date");

	obj.Day2 = xmlDoc2.getElementsByTagName("forecast")[2].getAttribute("day");
	obj.Day2Hi = xmlDoc2.getElementsByTagName("forecast")[2].getAttribute("high");
	obj.Day2Lo = xmlDoc2.getElementsByTagName("forecast")[2].getAttribute("low");
	obj.Day2Code = xmlDoc2.getElementsByTagName("forecast")[2].getAttribute("code");
	obj.Day2Date = xmlDoc2.getElementsByTagName("forecast")[2].getAttribute("date");

	obj.Day3 = xmlDoc2.getElementsByTagName("forecast")[3].getAttribute("day");
	obj.Day3Hi = xmlDoc2.getElementsByTagName("forecast")[3].getAttribute("high");
	obj.Day3Lo = xmlDoc2.getElementsByTagName("forecast")[3].getAttribute("low");
	obj.Day3Code = xmlDoc2.getElementsByTagName("forecast")[3].getAttribute("code");
	obj.Day3Date = xmlDoc2.getElementsByTagName("forecast")[3].getAttribute("date");

	obj.Day4 = xmlDoc2.getElementsByTagName("forecast")[4].getAttribute("day");
	obj.Day4Hi = xmlDoc2.getElementsByTagName("forecast")[4].getAttribute("high");
	obj.Day4Lo = xmlDoc2.getElementsByTagName("forecast")[4].getAttribute("low");
	obj.Day4Code = xmlDoc2.getElementsByTagName("forecast")[4].getAttribute("code");
	obj.Day4Date = xmlDoc2.getElementsByTagName("forecast")[4].getAttribute("date");
	UniAW(obj.icon,obj.sunset,obj.sunrise);
	updateDisplay();
}

function ForecastDayNames(day){
	if(weather_unit == 'c') {
		switch (day) {
			case "Mon": { return "Montag" }
			case "Tue": { return "Dienstag" }
			case "Wed": { return "Mittwoch" }
			case "Thu": { return "Donnerstag" }
			case "Fri": { return "Freitag" }
			case "Sat": { return "Samstag" }
			case "Sun": { return "Sonntag" }
			case "Mon,": { return "Montag" }
			case "Tue,": { return "Dienstag" }
			case "Wed,": { return "Mittwoch" }
			case "Thu,": { return "Donnerstag" }
			case "Fri,": { return "Freitag" }
			case "Sat,": { return "Samstag" }
			case "Sun,": { return "Sonntag" }
		}
	}
	return day;
}

function ForecastMonthNames(mon){
	if(weather_unit == 'c') {
    	switch (mon) {
        	case "Jan": { return "Januar"}
        	case "Feb": { return "Februar" }
			case "Mar": { return "März"}
        	case "Apr": { return "April" }
			case "May": { return "Mai" }
        	case "Jun": { return "Juni" }
			case "Jul": { return "Juli" }
        	case "Aug": { return "August" }
			case "Sep": { return "September"}
        	case "Oct": { return "Oktober" }
			case "Nov": { return "November" }
        	case "Dec": { return "Dezember" }
		}
	}
    return mon;
}


// Author : Vivek Thakur
// Date   : 25 Feb 2012
// No longer need appuuid
// Do not modify anything below this line unless you know what you are doing.
var prevlatitude = "";
var prevlongitude = "";
var woeid = "";
var textLat;
var textLong;

function UpdateLocation() {  
	document.getElementById("status").innerHTML = "UpdateLocation";
	
	jQuery.get('../../../../var/mobile/Documents/myLocation.txt', function(appdata) {
	//jQuery.get('myLocation.txt', function(appdata) {
		var myvar = appdata;
		var substr = appdata.split('\n');
		var templatitude=(substr[0]).split('=');
		var templongitude=(substr[1]).split('=');
		var latitude = $.trim(templatitude[1]);
		var longitude = $.trim(templongitude[1]);
		var Yahooappid =""
		if (prevlatitude != latitude || prevlongitude != longitude) {
			var url = "http://where.yahooapis.com/geocode?location=" + latitude + "+" + longitude + "&locale=de_DE&gflags=R&flags=J";
			
			$.getJSON(url, function(data) {
				obj.quality      = data.ResultSet.Results[0].quality;
				obj.latitude     = data.ResultSet.Results[0].latitude;
				obj.longitude    = data.ResultSet.Results[0].longitude;
				obj.radius       = data.ResultSet.Results[0].radius;
				obj.line1        = data.ResultSet.Results[0].line1;
				obj.line2        = data.ResultSet.Results[0].line2;
				obj.line3        = data.ResultSet.Results[0].line3;
				obj.line4        = data.ResultSet.Results[0].line4;
				obj.house        = data.ResultSet.Results[0].house;
				obj.street       = data.ResultSet.Results[0].street;
				obj.postal       = data.ResultSet.Results[0].postal;
				obj.neighborhood = data.ResultSet.Results[0].neighborhood; 
				obj.city         = data.ResultSet.Results[0].city;
				obj.county       = data.ResultSet.Results[0].county;
				obj.state        = data.ResultSet.Results[0].state;
				obj.country      = data.ResultSet.Results[0].country;
				obj.countrycode  = data.ResultSet.Results[0].countrycode;
				obj.statecode    = data.ResultSet.Results[0].statecode;
				obj.woeid        = data.ResultSet.Results[0].woeid;
				woeid            = data.ResultSet.Results[0].woeid;
				obj.woetype      = data.ResultSet.Results[0].woetype;
				obj.uzip         = data.ResultSet.Results[0].uzip;
				if (latitude < 0) {
					textLat = Math.round(latitude*100)/100 + "\u00B0" + "S";
				}
				else if (latitude > 0){
					textLat = Math.round(latitude*100)/100 + "\u00B0" + "N";
				}
				else {
					textLat = Math.round(latitude*100)/100 + "\u00B0";
				}
				if (longitude < 0) {
					textLong = Math.round(longitude*100)/100 + "\u00B0" + "W";
				}
				else if (longitude > 0) {
					textLong = Math.round(longitude*100)/100 + "\u00B0" + "E";
				}
				else {
					textLong = Math.round(longitude*100)/100 + "\u00B0";
				}
				obj.geo = textLat + " " + textLong;
				prevlatitude = latitude;
				prevlongitude = longitude;
				
    			
			});
		}	
	});
};

function lastDate(date){
	var help = date.split(" ");
	var day = ForecastDayNames(help[0]);
	var date = help[1];
	var month = ForecastMonthNames(help[2]);
	if(weather_unit == 'c') return day + ", " + date + ". " + month;
	else return day + " " + month + "  " + date;
	
}

function lastTime(date){
	var help = date.split(" ");
	if(weather_unit == 'c') {
		if (help[5] == "pm") {
			if(help[4].split(":")[0]*1<12) h3 = help[4].split(":")[0]*1+12;
			else h3 = help[4].split(":")[0]*1;
			h4 = help[4].split(":")[1];
			return h3 + ":" + h4;
		}
		else return help[4];
		
	}
	else return help[4] + " " + help[5];
	
}

function timeKorr(time){
	if(weather_unit != 'c') {
		var help = time.split(":");
		if(help[0] < 13) time = time + " am";
		else {
			time = help[0]-12 + ":" + help[1] + " pm";
		}
		
	}
	
	
	return time;
}
	
	

